# 281 "/usr/include/stdio.h"
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
# 47 "/usr/include/ctype.h"

enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
# 75 "/usr/include/ctype.h"

extern __const unsigned short int *__ctype_b;
# 290 "/h/27/yijun/software/vim61/src/vim.h"

typedef unsigned char char_u;
# 49 "/h/27/yijun/software/vim61/src/structs.h"

typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
# 356 "/h/27/yijun/software/vim61/src/option.h"

extern int p_dg;
# 360 "/h/27/yijun/software/vim61/src/option.h"

extern unsigned dy_flags;
# 12 "/h/27/yijun/software/vim61/src/proto/charset.pro"

int char2cells (int c);
# 33 "/h/27/yijun/software/vim61/src/proto/charset.pro"

char_u *skipwhite (char_u *p);
# 38 "/h/27/yijun/software/vim61/src/proto/charset.pro"

long getdigits (char_u **pp);
# 4 "/h/27/yijun/software/vim61/src/proto/digraph.pro"

int getdigraph (int char1, int char2, int meta);
# 8 "/h/27/yijun/software/vim61/src/proto/ex_getln.pro"

void putcmdline (int c, int shift);
# 33 "/h/27/yijun/software/vim61/src/proto/getchar.pro"

int safe_vgetc (void);
# 7 "/h/27/yijun/software/vim61/src/proto/message.pro"

int emsg (char_u *s);
# 17 "/h/27/yijun/software/vim61/src/proto/message.pro"

void msg_putchar (int c);
# 22 "/h/27/yijun/software/vim61/src/proto/message.pro"

int msg_outtrans (char_u *str);
# 48 "/h/27/yijun/software/vim61/src/proto/misc2.pro"

int ga_grow (garray_T *gap, int n);
# 12 "/h/27/yijun/software/vim61/src/proto/normal.pro"

int add_to_showcmd (int c);
# 12 "/h/27/yijun/software/vim61/src/proto/ui.pro"

void ui_breakcheck (void);
# 29 "/h/27/yijun/software/vim61/src/globals.h"

extern long Columns ;
# 83 "/h/27/yijun/software/vim61/src/globals.h"

extern int cmdline_star ;
# 124 "/h/27/yijun/software/vim61/src/globals.h"

extern int msg_col;
# 653 "/h/27/yijun/software/vim61/src/globals.h"

extern int no_mapping ;
# 654 "/h/27/yijun/software/vim61/src/globals.h"

extern int allow_keys ;
# 734 "/h/27/yijun/software/vim61/src/globals.h"

extern int must_redraw ;
# 747 "/h/27/yijun/software/vim61/src/globals.h"

extern int got_int ;
# 1054 "/h/27/yijun/software/vim61/src/globals.h"

extern char_u e_invarg[] ;
# 1106 "/h/27/yijun/software/vim61/src/globals.h"

extern char_u e_number[] ;
# 21 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

typedef char_u result_T;
# 24 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

typedef struct digraph
{
    char_u char1;
    char_u char2;
    result_T result;
} digr_T;
# 31 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

static int getexactdigraph (int, int, int);
# 32 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

static void printdigraph (digr_T *);
# 35 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

static garray_T user_digraphs = {0, 0, sizeof(digr_T), 10, ((void *)0)};
# 638 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

digr_T digraphdefault[] =
       {
        {'N', 'U', 0x0a},
        {'S', 'H', 0x01},
        {'S', 'X', 0x02},
        {'E', 'X', 0x03},
        {'E', 'T', 0x04},
        {'E', 'Q', 0x05},
        {'A', 'K', 0x06},
        {'B', 'L', 0x07},
        {'B', 'S', 0x08},
        {'H', 'T', 0x09},
        {'L', 'F', 0x0a},
        {'V', 'T', 0x0b},
        {'F', 'F', 0x0c},
        {'C', 'R', 0x0d},
        {'S', 'O', 0x0e},
        {'S', 'I', 0x0f},
        {'D', 'L', 0x10},
        {'D', '1', 0x11},
        {'D', '2', 0x12},
        {'D', '3', 0x13},
        {'D', '4', 0x14},
        {'N', 'K', 0x15},
        {'S', 'Y', 0x16},
        {'E', 'B', 0x17},
        {'C', 'N', 0x18},
        {'E', 'M', 0x19},
        {'S', 'B', 0x1a},
        {'E', 'C', 0x1b},
        {'F', 'S', 0x1c},
        {'G', 'S', 0x1d},
        {'R', 'S', 0x1e},
        {'U', 'S', 0x1f},
        {'S', 'P', 0x20},
        {'N', 'b', 0x23},
        {'D', 'O', 0x24},
        {'A', 't', 0x40},
        {'<', '(', 0x5b},
        {'/', '/', 0x5c},
        {')', '>', 0x5d},
        {'\'', '>', 0x5e},
        {'\'', '!', 0x60},
        {'(', '!', 0x7b},
        {'!', '!', 0x7c},
        {'!', ')', 0x7d},
        {'\'', '?', 0x7e},
        {'D', 'T', 0x7f},
        {'P', 'A', 0x80},
        {'H', 'O', 0x81},
        {'B', 'H', 0x82},
        {'N', 'H', 0x83},
        {'I', 'N', 0x84},
        {'N', 'L', 0x85},
        {'S', 'A', 0x86},
        {'E', 'S', 0x87},
        {'H', 'S', 0x88},
        {'H', 'J', 0x89},
        {'V', 'S', 0x8a},
        {'P', 'D', 0x8b},
        {'P', 'U', 0x8c},
        {'R', 'I', 0x8d},
        {'S', '2', 0x8e},
        {'S', '3', 0x8f},
        {'D', 'C', 0x90},
        {'P', '1', 0x91},
        {'P', '2', 0x92},
        {'T', 'S', 0x93},
        {'C', 'C', 0x94},
        {'M', 'W', 0x95},
        {'S', 'G', 0x96},
        {'E', 'G', 0x97},
        {'S', 'S', 0x98},
        {'G', 'C', 0x99},
        {'S', 'C', 0x9a},
        {'C', 'I', 0x9b},
        {'S', 'T', 0x9c},
        {'O', 'C', 0x9d},
        {'P', 'M', 0x9e},
        {'A', 'C', 0x9f},
        {'N', 'S', 0xa0},
        {'!', 'I', 0xa1},
        {'C', 't', 0xa2},
        {'P', 'd', 0xa3},
        {'C', 'u', 0xa4},
        {'Y', 'e', 0xa5},
        {'B', 'B', 0xa6},
        {'S', 'E', 0xa7},
        {'\'', ':', 0xa8},
        {'C', 'o', 0xa9},
        {'-', 'a', 0xaa},
        {'<', '<', 0xab},
        {'N', 'O', 0xac},
        {'-', '-', 0xad},
        {'R', 'g', 0xae},
        {'\'', 'm', 0xaf},
        {'D', 'G', 0xb0},
        {'+', '-', 0xb1},
        {'2', 'S', 0xb2},
        {'3', 'S', 0xb3},
        {'\'', '\'', 0xb4},
        {'M', 'y', 0xb5},
        {'P', 'I', 0xb6},
        {'.', 'M', 0xb7},
        {'\'', ',', 0xb8},
        {'1', 'S', 0xb9},
        {'-', 'o', 0xba},
        {'>', '>', 0xbb},
        {'1', '4', 0xbc},
        {'1', '2', 0xbd},
        {'3', '4', 0xbe},
        {'?', 'I', 0xbf},
        {'A', '!', 0xc0},
        {'A', '\'', 0xc1},
        {'A', '>', 0xc2},
        {'A', '?', 0xc3},
        {'A', ':', 0xc4},
        {'A', 'A', 0xc5},
        {'A', 'E', 0xc6},
        {'C', ',', 0xc7},
        {'E', '!', 0xc8},
        {'E', '\'', 0xc9},
        {'E', '>', 0xca},
        {'E', ':', 0xcb},
        {'I', '!', 0xcc},
        {'I', '\'', 0xcd},
        {'I', '>', 0xce},
        {'I', ':', 0xcf},
        {'D', '-', 0xd0},
        {'N', '?', 0xd1},
        {'O', '!', 0xd2},
        {'O', '\'', 0xd3},
        {'O', '>', 0xd4},
        {'O', '?', 0xd5},
        {'O', ':', 0xd6},
        {'*', 'X', 0xd7},
        {'O', '/', 0xd8},
        {'U', '!', 0xd9},
        {'U', '\'', 0xda},
        {'U', '>', 0xdb},
        {'U', ':', 0xdc},
        {'Y', '\'', 0xdd},
        {'T', 'H', 0xde},
        {'s', 's', 0xdf},
        {'a', '!', 0xe0},
        {'a', '\'', 0xe1},
        {'a', '>', 0xe2},
        {'a', '?', 0xe3},
        {'a', ':', 0xe4},
        {'a', 'a', 0xe5},
        {'a', 'e', 0xe6},
        {'c', ',', 0xe7},
        {'e', '!', 0xe8},
        {'e', '\'', 0xe9},
        {'e', '>', 0xea},
        {'e', ':', 0xeb},
        {'i', '!', 0xec},
        {'i', '\'', 0xed},
        {'i', '>', 0xee},
        {'i', ':', 0xef},
        {'d', '-', 0xf0},
        {'n', '?', 0xf1},
        {'o', '!', 0xf2},
        {'o', '\'', 0xf3},
        {'o', '>', 0xf4},
        {'o', '?', 0xf5},
        {'o', ':', 0xf6},
        {'-', ':', 0xf7},
        {'o', '/', 0xf8},
        {'u', '!', 0xf9},
        {'u', '\'', 0xfa},
        {'u', '>', 0xfb},
        {'u', ':', 0xfc},
        {'y', '\'', 0xfd},
        {'t', 'h', 0xfe},
        {'y', ':', 0xff},
        {'\000', '\000', '\000'}
       };
# 1998 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    int do_digraph(c)
    int c;
{
    static int backspaced;
    static int lastchar;

    if (c == -1)
    {
        backspaced = -1;
    }
    else if (p_dg)
    {
        if (backspaced >= 0)
            c = getdigraph(backspaced, c, 0);
        backspaced = -1;
        if ((c == (-(('k') + ((int)('b') << 8))) || c == 8) && lastchar >= 0)
            backspaced = lastchar;
    }
    lastchar = c;
    return c;
}
# 2026 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    int get_digraph(cmdline)
    int cmdline;
{
    int c, cc;

    ++no_mapping;
    ++allow_keys;
    c = safe_vgetc();
    --no_mapping;
    --allow_keys;
    if (c != '\033')
    {
        if (((c) < 0))
            return c;
        if (cmdline)
        {
            if (char2cells(c) == 1

                    && cmdline_star == 0

                    )
                putcmdline(c, 1);
        }

        else
            add_to_showcmd(c);

        ++no_mapping;
        ++allow_keys;
        cc = safe_vgetc();
        --no_mapping;
        --allow_keys;
        if (cc != '\033')
            return getdigraph(c, cc, 1);
    }
    return '\000';
}
# 2070 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    static int getexactdigraph(char1, char2, meta)
    int char1;
    int char2;
    int meta;
{
    int i;
    int retval = 0;
    digr_T *dp;

    if (((char1) < 0) || ((char2) < 0))
        return char2;




    dp = (digr_T *)user_digraphs.ga_data;
    for (i = 0; i < user_digraphs.ga_len; ++i)
    {
        if (dp->char1 == (unsigned)char1 && dp->char2 == (unsigned)char2)
        {
            retval = dp->result;
            break;
        }
        ++dp;
    }




    if (retval == 0)
    {
        dp = digraphdefault;
        for (i = 0; dp->char1 != 0; ++i)
        {
            if (dp->char1 == (unsigned)char1 && dp->char2 == (unsigned)char2)
            {
                retval = dp->result;
                break;
            }
            ++dp;
        }
    }






    if (retval == 0)
    {
        if (char1 == ' ' && meta)
            return (char2 | 0x80);
        return char2;
    }
    return retval;
}
# 2132 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    int getdigraph(char1, char2, meta)
    int char1;
    int char2;
    int meta;
{
    int retval;

    if (((retval = getexactdigraph(char1, char2, meta)) == char2)
            && (char1 != char2)
            && ((retval = getexactdigraph(char2, char1, meta)) == char1))
        return char2;
    return retval;
}
# 2151 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    void putdigraph(str)
    char_u *str;
{
    int char1, char2, n;
    int i;
    digr_T *dp;

    while (*str != '\000')
    {
        str = skipwhite(str);
        if (*str == '\000')
            return;
        char1 = *str++;
        char2 = *str++;
        if (char2 == 0)
        {
            emsg((char_u *)(((char *)(e_invarg))));
            return;
        }
        if (char1 == '\033' || char2 == '\033')
        {
            emsg((char_u *)(((char *)("E104: Escape not allowed in digraph"))));
            return;
        }
        str = skipwhite(str);
        if (!(__ctype_b[(int) ((*str))] & (unsigned short int) _ISdigit))
        {
            emsg((char_u *)(((char *)(e_number))));
            return;
        }
        n = getdigits(&str);


        dp = (digr_T *)user_digraphs.ga_data;
        for (i = 0; i < user_digraphs.ga_len; ++i)
        {
            if (dp->char1 == (unsigned)char1 && dp->char2 == (unsigned)char2)
            {
                dp->result = n;
                break;
            }
            ++dp;
        }


        if (i == user_digraphs.ga_len)
        {
            if (ga_grow(&user_digraphs, 1) == 1)
            {
                dp = (digr_T *)user_digraphs.ga_data + user_digraphs.ga_len;
                dp->char1 = char1;
                dp->char2 = char2;
                dp->result = n;
                ++user_digraphs.ga_len;
                --user_digraphs.ga_room;
            }
        }
    }
}
# 2212 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    void listdigraphs()
{
    int i;
    digr_T *dp;

    msg_putchar('\n');

    dp = digraphdefault;
    for (i = 0; dp->char1 != '\000' && !got_int; ++i)
    {
        if (getexactdigraph(dp->char1, dp->char2, 0) == dp->result



                )
            printdigraph(dp);
        ++dp;
        ui_breakcheck();
    }

    dp = (digr_T *)user_digraphs.ga_data;
    for (i = 0; i < user_digraphs.ga_len && !got_int; ++i)
    {
        printdigraph(dp);
        ui_breakcheck();
        ++dp;
    }
    must_redraw = 50;

}
# 2244 "/h/27/yijun/software/vim61/src/digraph.cpp.c"

    static void printdigraph(dp)
    digr_T *dp;
{
    char_u buf[30];
    char_u *p;

    int list_width;

    if ((dy_flags & 0x002)



            )
        list_width = 13;
    else
        list_width = 11;

    if (dp->result != 0)
    {
        if (msg_col > Columns - list_width)
            msg_putchar('\n');
        if (msg_col)
            while (msg_col % list_width != 0)
                msg_putchar(' ');

        p = buf;
        *p++ = dp->char1;
        *p++ = dp->char2;
        *p++ = ' ';
            *p++ = dp->result;
        if (char2cells(dp->result) == 1)
            *p++ = ' ';
        sprintf((char *)p, " %3d", dp->result);
        msg_outtrans(buf);
    }
}
